;I2C-Bus       (I2C_2.ASM)
;11,059MHz, 9600 Baud
;PCF8591
#include 8051.H
         .org 0000H

ANFANG   mov   SP,#60H    ;Stackpointer setzten
INIT     clr   TR1        ;Timer 1 stoppen
         mov   TH1,#0FAH  ;6 bis berlauf: 9600 Baud
         mov   TL1,#0FAH
         anl   TMOD,#0FH  ;Timer1: 8-Bit-Auto-Reload
         orl   TMOD,#20H
         setb  TR1        ;Timer Starten
         mov   SCON,#50H  ;InitRS232
         setb  TI
         orl   PCON,#80H  ;SMOD=1

NEXT     acall EMPF       ;DA-Daten
         mov   r7,a
         acall I2Start 
         mov   a,#144     ;Adresse PCF8591, schreiben
         acall I2Out
         mov   a,#68      ;DA aktiv, Messen ab 0
         acall I2Out
         mov   a,r7       ;Datenbyte
         acall I2Out
         acall I2Stop
         acall I2Start 
         mov   a,#145     ;Adresse PCF8591, lesen
         acall I2Out
         acall I2In       ;Leerlaufmessung
         acall I2Ack
         acall I2In
         acall I2Ack
         acall SEND       ;Kanal 0       
         acall I2In
         acall I2Ack
         acall SEND       ;Kanal 1       
         acall I2In
         acall I2Ack
         acall SEND       ;Kanal 2       
         acall I2In
         acall I2Nak      ;letztes Byte
         acall I2Stop
         acall SEND       ;Kanal 3       
         sjmp  NEXT

EMPF     jnb   RI,EMPF
         mov   A,SBUF
         clr   RI
         ret

SEND     jnb   TI,SEND
         clr   TI
         mov   SBUF,A
         ret

SDA      .equ  92h   ;Port 1.2
SCL      .equ  93h   ;Port 1.3

Delay    nop
         nop
         ret

I2Init   setb  SDA
         setb  SCL
         ret

I2Start  clr   SDA
         acall Delay
         clr   SCL
         ret

I2Stop   clr   SCL
         clr   SDA
         acall Delay
         setb  SCL
         acall Delay
         setb  SDA
         ret

I2Ack    clr   SDA
         acall Delay
         setb  SCL
         acall Delay
         clr   SCL
         acall Delay
         ret

I2Nak    setb  SDA
         acall Delay
         setb  SCL
         acall Delay
         clr   SCL
         acall Delay
         ret


I2Out    mov   r3,#8     ;8 Datenbits
S0       jb    ACC.7,S1  ;Bit 7 = 1?
         clr   SDA       ;Bit = 0
         sjmp  S2        ;Bit = 1
S1       setb  SDA       ;Bit = 1
S2       acall Delay
         setb  SCL       ;Clock-Impuls
         acall Delay
         clr   SCL
         rl    a         ;nchtes Bit in A
         djnz  r3,S0     ;8 mal 
         setb  SDA       ;SDA hochohmig
         acall Delay
         setb  SCL       ;9. Clockimpuls
         acall Delay
         jb    SDA,Err   ;Ack vom Slave?
         clr   SCL
         clr   SDA 
         acall Delay
         ret
Err      mov   A,#0      ;Error: 0 zurck
         clr   SCL
         clr   SDA 
         acall Delay
         ret

I2In     setb  SDA       ;SDA hochohmig
         mov   A,#0 
         mov   r3,#8     ;8 Datenbits
S4       rl    A         ;nchstes Bit
         setb  SCL       ;Clockimpuls
         acall Delay
         jnb   SDA,S5    ;SDA = 0?
         inc   A         ;Bit 0 = 1
S5       clr   SCL
         acall Delay
         djnz  r3,S4     ;8 mal
         ret

        .end
